#ifndef _INTERRUPT_H_
#define _INTERRUPT_H_

/* #include <io.h> */
#include <reg1010.h>
#include <hal.h>

#define sei()  INT_GLOBAL_ENABLE(TRUE)
#define cli()  INT_GLOBAL_ENABLE(FALSE)
#define sefi() INT_FLASHDEBUG_ENABLE(TRUE)
#define clfi() INT_FLASHDEBUG_ENABLE(FALSE)


#ifdef __cplusplus
extern "C" {
#endif

extern inline void enable_external_int (unsigned char ints)
{
	IE |= (ints & 0x05); // Mask IE.EX0 (bit 0) and IE.EX1 (bit 2)
}

extern inline void timer01_enable_int (unsigned char ints)
{
	IE |= (ints & 0x0A); // Mask IE.ET0 (bit 1) and IE.ET1 (bit 3)
}

extern inline void timer23_enable_int (unsigned char ints)
{
	EIE |= (ints & 0x0A); // Mask IE.ET2 (bit 1) and IE.ET3 (bit 3)
}

extern inline void timer_enable_int (unsigned char ints)
{
	timer01_enable_int(ints);
}

#ifdef __cplusplus
}
#endif

#endif
